

package com.office.allreader.allofficefilereader.fc.dom4j.jaxb;

import com.office.allreader.allofficefilereader.fc.dom4j.Element;

/**
 * JAXBObjectHandler implementations can be registered with the JAXB Reader in
 * order to receive unmarshalled XML fragments.
 * 
 * @author Wonne Keysers (Realsoftware.be)
 */
public interface JAXBObjectHandler
{
    /**
     * Called when the {@link JAXBReader}has finished parsing the xml path the
     * handler was registered for. The provided object is the unmarshalled
     * representation of the XML path. It can be casted to the appropriate
     * implementation class that is generated by the JAXB compiler.
     * 
     * @param jaxbElement
     *            the unmarshalled JAXB object to handle
     * 
     * @throws Exception
     *             of any kind, thrown by the implementation
     */
    void handleObject(Element jaxbElement) throws Exception;
}

