

package com.office.allreader.allofficefilereader.fc.ss.usermodel;

/**
 * The enumeration value indicating the line style of a border in a cell,
 * i.e., whether it is borded dash dot, dash dot dot, dashed, dotted, double, hair, medium, 
 * medium dash dot, medium dash dot dot, medium dashed, none, slant dash dot, thick or thin.
 */
 public enum BorderStyle {

    /**
     * No border
     */

    NONE,

    /**
     * Thin border
     */

    THIN,

    /**
     * Medium border
     */

    MEDIUM,

    /**
     * dash border
     */

    DASHED,

    /**
     * dot border
     */

    HAIR,

    /**
     * Thick border
     */

    THICK,

    /**
     * double-line border
     */

    DOUBLE,

    /**
     * hair-line border
     */

    DOTTED,

    /**
     * Medium dashed border
     */

    MEDIUM_DASHED,

    /**
     * dash-dot border
     */

    DASH_DOT,

    /**
     * medium dash-dot border
     */

    MEDIUM_DASH_DOT,

    /**
     * dash-dot-dot border
     */

    DASH_DOT_DOT,

    /**
     * medium dash-dot-dot border
     */

    MEDIUM_DASH_DOT_DOTC,

    /**
     * slanted dash-dot border
     */

    SLANTED_DASH_DOT;

}
