package com.office.reader.viewer.activity

import android.app.Dialog
import android.content.Context
import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import android.view.WindowManager
import android.widget.TextView
import android.widget.Toast
import androidx.core.content.FileProvider
import com.office.allreader.allofficefilereader.BuildConfig
import com.office.allreader.allofficefilereader.R
import com.office.reader.viewer.util.Constants
import com.office.reader.viewer.util.Utils
import com.github.barteksc.pdfviewer.scroll.DefaultScrollHandle
import com.office.reader.viewer.model.OnActionCallBack
import com.office.reader.viewer.util.Utils.downLoadFromNet
import kotlinx.android.synthetic.main.activity_pdf_viewer.*
import kotlinx.android.synthetic.main.activity_pdf_viewer.pdfView
import kotlinx.android.synthetic.main.layout_dialog_gotopage.*
import java.io.File
import java.lang.Exception

class PdfViewerActivity : AppCompatActivity() {

    private lateinit var mUrlFilePdf: String
    private var mIsShowMenu = false
    private var mIsFavorite = false
    private var titleBar: TextView? = null
    private var context: Context? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_pdf_viewer)
        titleBar = findViewById<TextView>(R.id.title)
        context = this
        initData()
        handleEvents()
    }

    private fun initData() {
        context = this
        mUrlFilePdf = intent.getStringExtra(Constants.URL)!!
        titleBar!!.text = intent.getStringExtra(Constants.TITLE)
        if (this.mUrlFilePdf.startsWith("http")) {
            Utils.downLoadFromNet(mUrlFilePdf,object : OnActionCallBack<String> {
                override fun onResponse(data: String) {
                    pdfView.fromFile(File(data))
                            .enableSwipe(true)
                            .defaultPage(0)
                            .enableAnnotationRendering(true)
                            .scrollHandle(DefaultScrollHandle(context))
                            .load()
                }
            })
        } else {
                    pdfView.fromFile(File(mUrlFilePdf))
            .enableSwipe(true)
            .defaultPage(0)
            .enableAnnotationRendering(true)
            .scrollHandle(DefaultScrollHandle(this))
            .load()
        }

    }

    private fun handleEvents() {
        btnBack.setOnClickListener {
            onBackPressed()
        }
    }

    override fun onBackPressed() {
        val returnIntent = Intent()
        setResult(RESULT_OK, returnIntent)
        finish()
    }
}